--- chan_sip.c	2012-05-29 12:55:55.000000000 +0200
+++ chan_sip.c	2012-05-29 12:55:58.000000000 +0200
@@ -8673,6 +8673,12 @@
 	}
 	/* No address for RTP, we're on hold */
 
+	/* clear flags to fix bug when call goes from one holdstate to another (for example SIP_PAGE2_CALL_ONHOLD_INACTIVE to SIP_PAGE2_CALL_ONHOLD_ONEDIR) */
+	ast_clear_flag(&dialog->flags[1], SIP_PAGE2_CALL_ONHOLD_ONEDIR);
+	ast_clear_flag(&dialog->flags[1], SIP_PAGE2_CALL_ONHOLD_INACTIVE);
+	ast_clear_flag(&dialog->flags[1], SIP_PAGE2_CALL_ONHOLD_ACTIVE);
+
+
 	if (sendonly == 1)	/* One directional hold (sendonly/recvonly) */
 		ast_set_flag(&dialog->flags[1], SIP_PAGE2_CALL_ONHOLD_ONEDIR);
 	else if (sendonly == 2)	/* Inactive stream */
